VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "GetOrder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Function GetXMLOrder(ByVal strServerName As String, _
                            ByVal strUserName As String, _
                            ByVal strPassword As String, _
                            ByVal strOrder As String) As String
   
   'Serialize a Northwind order to XML

   Dim strConnect As String
   Dim strSQL As String
   Dim strXML As String
   Dim intCol As Integer
   
   Dim cnnNwind As New ADODB.Connection
   Dim rstNwind As New ADODB.Recordset
   
   On Error GoTo ErrGetXML
   
   strConnect = "Provider=SQLOLEDB;Data Source=" & strServerName & _
   ";Initial Catalog=Northwind;UID=" & strUserName & ";PWD=" & strPassword
   cnnNwind.Open (strConnect)
   
   strSQL = "SELECT OrderID, OrderDate, ShippedDate, Freight, CustomerID, " & _
            "ShipName, ShipAddress, ShipCity, " & _
            "ShipRegion, ShipPostalCode, ShipCountry " & _
            "FROM Orders WHERE OrderID = " & strOrder
   
   'Serialize the order data
   'strXML = "<?xml version='1.0' encoding = 'UTF-8' ?>" & vbCrLf & _
   '         "<ProcessInvoice xmlns='http://schemas.oakleaf.ws/Order'>" & vbCrLf
   strXML = "<Order xmlns='http://schemas.oakleaf.ws/order/'>" & vbCrLf
   
   With rstNwind
      Set .ActiveConnection = cnnNwind
      .CursorLocation = adUseClient
      .CursorType = adOpenStatic
      .Source = strSQL
      .Open
      For intCol = 0 To .Fields.Count - 1
         If IsNull(.Fields(intCol).Value) Then
            'Empty Region or PostalCode value
            strXML = strXML & "   <" & CStr(.Fields(intCol).Name) & ">" & _
               "</" & CStr(.Fields(intCol).Name) & ">" & vbCrLf
         Else
            strXML = strXML & "   <" & CStr(.Fields(intCol).Name) & ">" & _
               CStr(.Fields(intCol).Value) & "</" & CStr(.Fields(intCol).Name) & ">" & vbCrLf
         End If
      Next intCol
      .Close
   End With
   
   'Add the line items as nested elements
   strSQL = "SELECT ProductID, Quantity, UnitPrice, Discount " & _
            "FROM [Order Details] " & _
            "Where OrderID = " & strOrder
            
   strXML = strXML & "   <LineItems>" & vbCrLf
   With rstNwind
      Set .ActiveConnection = cnnNwind
     .CursorLocation = adUseClient
      .CursorType = adOpenStatic
      .Source = strSQL
      .Open
      Do Until .EOF
         strXML = strXML & Space$(6) & "<Item>" & vbCrLf
         For intCol = 0 To .Fields.Count - 1
            strXML = strXML & Space$(9) & "<" & CStr(.Fields(intCol).Name) & ">" & _
               CStr(.Fields(intCol).Value) & "</" & CStr(.Fields(intCol).Name) & ">" & vbCrLf
         Next intCol
         strXML = strXML & Space$(6) & "</Item>" & vbCrLf
         .MoveNext
      Loop
      .Close
   End With
   cnnNwind.Close
   
   strXML = strXML & "   </LineItems>" & vbCrLf & "</Order>"
   GetXMLOrder = strXML
   GoTo ExitGetXML
   
ErrGetXML:
   GetXMLOrder = "Error: " & Err.Description
   GoTo ExitGetXML
   
ExitGetXML:
   Set rstNwind = Nothing
   Set cnnNwind = Nothing
End Function


